#ifndef __ARGUMENTS_H__
#define __ARGUMENTS_H__
#include <memory>
#include "log.h"
#include "cursor.h"
#include "display.h"
#include "input.h"
#include "rng.h"


#include "constants.h"

/* Arguments
-n        : Use ncurses for I/O
-r        : Randomly generate maps
-m        : Enabled a main menu + options
-c        : Enemies chase the player (through doors and up stairs)
-i        : Enable inventory
-t        : Enable throw
-R        : Enable revisiting levels
-s [seed] : Sets initial seed to seed
-L [file] : Enable logging to file
-I [file] : Reads commands from file. CANNOT BE USED WITH -n.
-O [file] : Outputs to file. CANNOT BE USED WITH -n.
-h/--help : Displays options list (doesn't start a game)
 */

// IMPORTANT: Errors include the index that caused them (or'ed into them)
feature proc_args(int argc, char **argv,
                  std::unique_ptr<cursor>  &curse,
                  std::unique_ptr<input>   &in,
                  std::unique_ptr<display> &out,
                  std::unique_ptr<logger>  &log,
                  std::unique_ptr<RNG>     &rng);

void panic_args(feature panic);

#endif
